// Ball.h

#pragma once

enum Area
{
    Free,
    Blue,
    Red
};

class Ball
{
    double Bx,By;       // {[݈ʒu
    double yBx,yBy;     // Pb̃{[̗\ʒu
    Area AreaFlag;       // ǂ̃GAɃ{[邩
    double kBx,kBy;     // L[p[n_Ƃ̌_
    double Spd;         // {[̑x
    double Vx,Vy;       // {[̈ړxiwAxj
    int HomeX,HomeY;    // z[|WViJnAsb`j
public:
    void Init(int HomeX, int HomeY);
    int getBx(){return static_cast<int>(Bx);}
    int getBy(){return static_cast<int>(By);}
    double getSpd(){return Spd;}
    void Kick(int LocX, int LocY, double Spd);
    bool Move();
    void Yosoku();
    void YosokuKeeperArea();
    int getYBx(){return static_cast<int>(yBx);}
    int getYBy(){return static_cast<int>(yBy);}
    Area getArea(){return AreaFlag;}
    int getKBx(){return static_cast<int>(kBx);}
    int getKBy(){return static_cast<int>(kBy);}

};

void Ball::Init(int hx, int hy){
    Bx = yBx = HomeX = hx;
    By = yBy = HomeY = hy;
    Vx = Vy = 0.0;
    AreaFlag = Free;
    kBx = 300.0;
    kBy = 150.0;
    Spd = 0.0;
}

// {[RiڕWn_ɌRo߂j
void Ball::Kick(int LocX, int LocY, double Spd)
{
    double Yaw = atan2(LocY - By, LocX - Bx);
    this->Spd = Spd;
    Vx = cos(Yaw);
    Vy = sin(Yaw);
}

void Ball::Yosoku()
{
    double dSpd = Spd;
    yBx = Bx;
    yBy = By;

    // 60t[iPbj̈ʒuǂ
    for(int i = 0; i< 60; i++){
        yBx += Vx * dSpd;
        yBy += Vy * dSpd;
        dSpd *= 0.98;
    }
    if(yBx<0.0) yBx = -yBx;
    if(yBy<0.0) yBy = -yBy;
    if(yBx>600.0) yBx = 600.0-(yBx-600.0);
    if(yBy>300.0) yBy = 300.0-(yBy-300.0);

}

void Ball::YosokuKeeperArea()
{
    double Yaw;
    AreaFlag = Free;
    if(yBx < 250){
        // {[\zn_R̂Ƃ
        Yaw = atan2(yBy - 150, yBx - (-50));
        kBx = -50 + cos(Yaw)*100;
        kBy = 150 + sin(Yaw)*100;
        AreaFlag = Blue;
    }else if(yBx>350){
        // {[\zn_ԌR̂Ƃ
        Yaw = atan2(yBy - 150, yBx - 650);
        kBx = 650 + cos(Yaw)*100;
        kBy = 150 + sin(Yaw)*100;
        AreaFlag = Red;
    }
    return;
}

bool Ball::Move()
{
    Bx += Vx*Spd;
    By += Vy*Spd;

    Spd *= 0.98;     // nʂƂ̖CɂA]Xs[h
    if(Spd < 0.001) { Spd = 0.0; Vx = Vy = 0.0;}

    // ǂ̔˂ƃS[
    if(By<0.0){Vy=-Vy;By=0.0;}
    if(By>300.0){Vy=-Vy;By=300.0;}

    if((Bx<0.0)||(Bx>600.0)){
        Vx=-Vx;
        if(Bx<300.0) Bx=0.0;
        else Bx=600.0;
        if((By>=100.0)&&(By<=200.0)){
            return true;
        }
    }
    Yosoku();
    YosokuKeeperArea();
    return false;
}