// Player.h

enum PlayerStatus{
    NONE,
    WAIT,           // ҋ@
    CHASE_BALL,     // {[ǂ
    GET_BALL,       // {[Ă
    ATTACK,         // ͂ƂĂ̍U
    SUPPORT,        // T|[g
    CUTIN,          // pXJbgłȂ犄荞
    GO_HOME         // ̎ʒuɖ߂
};
enum Position{
    GOALKEEPER,
    DEFENDER,
    ATTACKER
};

enum TeamColor{
    BLUE,
    RED
};

class Player
{
    TeamColor Team;             // ǂ̃`[ɏĂ邩
    Position Pos;               // |WV
    double Px,Py;               // vC[W
//    double Yaw;                 // vC[̌
    PlayerStatus Status;        // vC[̏
    int HomeX,HomeY;             // ʒui߂ׂWj
    int SetX, SetY;              // ڕWn_
public:
    void Init(TeamColor Team,Position Pos, double Px,double Py, int HomeX, int HomeY);
    int getPx(){return static_cast<int>(Px);}
    int getPy(){return static_cast<int>(Py);}
    int getPos(){return Pos;}
    PlayerStatus getStatus(){return Status;}
    void setStatus(PlayerStatus Status){this->Status = Status;}
    TeamColor getTeam(){return Team;}
    void GoLocate(PlayerStatus st, int LocX, int LocY);
    void GoHomePos();
    void Move();
};

void Player::Init(TeamColor Team,Position Pos, double Px, double Py, int HomeX, int HomeY)
{
    this->Team = Team;
    this->Pos = Pos;
    this->Px = Px;
    this->Py = Py;
    this->HomeX = HomeX;
    this->HomeY = HomeY;
    GoLocate( GO_HOME,HomeX,HomeY);
}

void Player::GoLocate(PlayerStatus st, int LocX, int LocY)
{
    Status = st;
    SetX = LocX;
    SetY = LocY;
}

void Player::GoHomePos()
{
    Status = GO_HOME;
    SetX   = HomeX;
    SetY   = HomeY;
}

void Player::Move()
{
    if(Status==WAIT)return;

    double rad = atan2(SetY - Py, SetX - Px);
    double c = cos(rad);
    double s = sin(rad);

    Px += c;
    Py += s;

    if(Status!=SUPPORT){
        if(((SetY-Py)*(SetY-Py)+(SetX-Px)*(SetX-Px))<4){
            Px = SetX;
            Py = SetY;
        }
    }

    if((Status==GO_HOME)&&(getPx()==HomeX)&&(getPy()==HomeY))Status = WAIT;

}

